=begin
 distributed Ruby --- NamedObject Sample
 	Copyright (c) 2000 Masatoshi SEKI 
	$Id: name.rb,v 1.5 2000/09/17 00:09:34 mas Exp $ 
=end

=begin
 How to play.

 Terminal 1
 | % ruby name.rb
 | druby://yourhost:7640

 Terminal 2
 | % ruby namec.rb druby://yourhost:7640

=end

require 'thread.rb'
require 'drb/drb'

module DRbNamedObject
  attr_reader(:drb_name)
end

class DRbNamedIdConv < DRbIdConv
  def initialize
    @dict = Hash.new
  end
  attr_reader(:dict)

  def to_obj(ref)
    @dict.fetch(ref) do super end
  end

  def to_id(obj)
    if obj.kind_of? DRbNamedObject
      @dict[obj.drb_name] = obj
      return obj.drb_name 
    else
      return super
    end
  end

  def forget(name)
    @dict.delete(name)
  end

  def regist(obj)
    @dict[obj.drb_name] = obj
  end
end

class Seq
  include DRbUndumped
  include DRbNamedObject

  def initialize(v, name)
    @counter = v
    @mutex = Mutex.new
    @drb_name = name
  end

  def next_value
    @mutex.synchronize do
      @counter += 1
      return @counter
    end
  end
end

class Front
  def initialize(dict)
    @dict = dict
  end
    
  def [](k)
    @dict[k]
  end

  def obj(k)
    @dict[k]
  end
end

if __FILE__ == $0
  name_conv = DRbNamedIdConv.new
  name_conv.regist(Seq.new(0, "seq a"))
  name_conv.regist(Seq.new(0, "seq b"))

  DRb.install_id_conv(name_conv)
  DRb.start_service(nil, Front.new(name_conv.dict))

  puts DRb.uri
  DRb.thread.join
end

