=begin
 Tiny Ruby Linda
 	Copyright (c) 1999-2000 Masatoshi SEKI 
	$Id: rinda.rb,v 1.6 2000/05/22 17:06:30 mas Exp $ 
=end

require 'drb/drb'
require 'tuplespace'
require 'thread'

class TupleSpace
  def move(dest, template, non_block=false)
    tuple = self.in(template, non_block)
    begin
      dest.out(tuple)
    rescue
      self.out(tuple)
    end
  end
end

class TupleSpaceProxy
  def initialize(remote)
    @remote = remote
    @local = TupleSpace.new
  end

  def out(*tuples)
    @remote.out(*tuples)
  end

  def in(template, non_block=false)
    @remote.move(DRbObject.new(@local), template, non_block)
    @local.in(template, non_block)
  end
end


if __FILE__ == $0
  DRb.start_service('druby://:7640', TupleSpace.new)
  puts DRb.uri
  DRb.thread.join
end


